<?php

namespace Drupal\openinbound\Plugin\YamlFormHandler;

use Drupal\Core\Form\FormStateInterface;
use Drupal\yamlform\YamlFormHandlerBase;
use Drupal\yamlform\YamlFormSubmissionInterface;
use Drupal\openinbound\Controller\OI;

/**
 * YAML form submission debug handler.
 *
 * IMPORTANT: This handler is exactly the same as the one in the
 * yamlform_test.module. It does not really matter which one is loaded.
 *
 * @YamlFormHandler(
 *   id = "openinbound",
 *   label = @Translation("OpenInbound"),
 *   category = @Translation("OpenInbound"),
 *   description = @Translation("Submissions to OpenInbound Contact."),
 *   cardinality = \Drupal\yamlform\YamlFormHandlerInterface::CARDINALITY_SINGLE,
 *   results = \Drupal\yamlform\YamlFormHandlerInterface::RESULTS_PROCESSED,
 * )
 */
class InboundYamlFormHandler extends YamlFormHandlerBase {

    /**
     * {@inheritdoc}
     */
    public function submitForm(array &$form, FormStateInterface $form_state, YamlFormSubmissionInterface $yamlform_submission) {

        $data = $yamlform_submission->getData();
        $config = \Drupal::service('config.factory')->getEditable('openinbound.settings');
        $oi = new OI($config->get('settings.openinbound_tracking_id'), $config->get('settings.openinbound_api_key'));
        \Drupal::logger('oi_debug_tracker_js')->notice(print_r($_COOKIE,1));
        \Drupal::logger('oi_debug_tracker_js')->notice(print_r($data,1));

        $oi->updateContact($_COOKIE['_oi_contact_id'], $data);
        //$data = $yamlform_submission->getData();
        //\Drupal\inbound\Controller\debug_raw($_COOKIE);
        //\Drupal\inbound\Controller\debug_raw($data);
        //$build = ['#markup' => 'Submitted values are:<pre>' . Yaml::encode($yamlform_submission->getData()) . '</pre>'];
        //drupal_set_message(\Drupal::service('renderer')->render($build), 'warning');
    }

}
